/*-------------------------------------------------------------------*\
      
     0.51 beta
	() 2002   a.k.a. FighteR

  LoadProg.cpp --     
\*-------------------------------------------------------------------*/

#include <malloc.h>
#include "CaseGen.h"

#define BLCOM_BEG_SIGN "/*"
#define BLCOM_END_SIGN "*/"
#define LINECOM_SIGN   "//"


LPSTR pszError = " .";


static long GetFileLength (FILE *fp);
void ClipComment(LPSTR szLine, LPCSTR szCommentSign);
void CutSubString(LPSTR szString, int iSubBeg, int iSubLen);
int FindSubString(LPCSTR szString, LPCSTR szSubString);


/*----------------------------------------------------------------*\
   Prog.txt  
	aszVarString[10][], *aszCaseLogic[6];
      TRUE
     FALSE   pszError
\*----------------------------------------------------------------*/
BOOL LoadProg(LPCSTR szProgFileName)
{
	long iFileLength;
	char szBuffer[MAX_STRLEN];
	char szToken [MAX_STRLEN];
	int iVar;
	int iCase = NOT_CASE;
	FILE *fp;

  try	//    try{...}catch    
  {

	if (NULL == (fp = fopen(szProgFileName, "r")))
		throw "   -!";

	for(iVar = 0; iVar < 10; iVar++) 
		lstrcpy (aszVarString[iVar], "");

	iFileLength = GetFileLength(fp);


	for(iCase = NOMINATIVE; iCase <= ALL_CASES; iCase++)
	{
		if (NULL == (aszCaseLogic[iCase] = (LPSTR)malloc(iFileLength + 1))) //  
			throw "    -!";

		lstrcpy (aszCaseLogic[iCase], "");
	}

	bool bBlComMode = false;

	while (!feof(fp))
	{
		fgets(szBuffer, MAX_STRLEN, fp);

			//   
		int  iBlComLen, iBlComBeg = 0;

		if (bBlComMode)
		{
			if((iBlComLen = FindSubString(szBuffer, BLCOM_END_SIGN)) < 0) continue;
			bBlComMode = false;
			CutSubString(szBuffer, 0, iBlComLen + lstrlen(BLCOM_END_SIGN));
		}

		while ((iBlComBeg += FindSubString(szBuffer + iBlComBeg, BLCOM_BEG_SIGN)) >= 0)
		{
				//       ...
			if ((iBlComLen = FindSubString(szBuffer + iBlComBeg, BLCOM_END_SIGN)) >= 0)
			{
				CutSubString(szBuffer, iBlComBeg, iBlComLen + lstrlen(BLCOM_END_SIGN));
				continue;	//       !
			}else{
				ClipComment(szBuffer, BLCOM_BEG_SIGN);
				bBlComMode = true;
				break;
			}
		}

		if (FindSubString(szBuffer, BLCOM_END_SIGN) >= 0)
			throw (" \"" BLCOM_END_SIGN "\"   !");

		ClipComment(szBuffer, LINECOM_SIGN);

		TakeWord(1, szToken, szBuffer);

		if(lstrlen(szToken) == 0) continue;

		if( 0 == lstrcmp (szToken, "#"       )){ iCase = NOT_CASE;      continue;}
		if( 0 == lstrcmp (szToken, "#")){ iCase = NOMINATIVE;    continue;}
		if( 0 == lstrcmp (szToken, "#" )){ iCase = GENITIVE;      continue;}
		if( 0 == lstrcmp (szToken, "#"   )){ iCase = DATIVE;        continue;}
		if( 0 == lstrcmp (szToken, "#" )){ iCase = ACCUSATIVE;    continue;}
		if( 0 == lstrcmp (szToken, "#")){ iCase = INSTRUMENTAL;  continue;}
		if( 0 == lstrcmp (szToken, "#"  )){ iCase = PREPOSITIONAL; continue;}
		if( 0 == lstrcmp (szToken, "#_"  )){ iCase = ALL_CASES;     continue;}
		
		if( 0 == lstrcmp (szToken, "#"))
		{
			TakeWord(2, szToken, szBuffer);
			iVar = szToken[0] - '0';
			if(iVar < 0 || iVar > 9) continue;

			TakeWord(3, szToken, szBuffer);
			lstrcpy (aszVarString[iVar], (szToken == NULL) ? "" : szToken);
			continue;
		}

		if(szToken[0] == '#') throw "   -!";

		if(iCase == NOT_CASE){
			//MessageBox(NULL, szBuffer, szToken, MB_OK);
			throw "   \"#< > ... #\"  !";
		}else{
			lstrcat(aszCaseLogic[iCase], szBuffer);
		}
	}
	if (bBlComMode) throw ("  "
		BLCOM_BEG_SIGN " ... " BLCOM_END_SIGN "     -!");

		//  	
	for(iCase = NOMINATIVE; iCase <= ALL_CASES; iCase++)
	{
		LPSTR pszT;
		if (NULL != (pszT = (LPSTR)realloc (aszCaseLogic[iCase],
			1 + lstrlen(aszCaseLogic[iCase]))))
		{
			aszCaseLogic[iCase] = pszT;
		}
	}
	fclose(fp);
	return TRUE;
  }
  catch(LPSTR szError)	//  
  {
	  if(fp != NULL) fclose(fp);
	  pszError = szError;
	  return FALSE;
  }
}

		
static long GetFileLength (FILE *fp)
{
	long iCurPos, iFileLength;
    
	iCurPos = ftell(fp);
    fseek (fp, 0, SEEK_END);
    iFileLength = ftell(fp);

    fseek (fp, iCurPos, SEEK_SET);

    return iFileLength;
}



/*-----------------------------------------------------------*\
        
  ,  -1,     
\*-----------------------------------------------------------*/
int FindSubString(LPCSTR szString, LPCSTR szSubString)
{
	int i, iSym = 0;
	for(i = 0; i < lstrlen(szString); i++)
	{
		if(szString[i] == szSubString[iSym]){
			iSym++;
			if(szSubString[iSym] == '\0')
				return i - iSym + 1;
		}else{
			 i -= iSym;
			 iSym = 0;
		}
	}
	return -1;
}


void CutSubString(LPSTR szString, int iSubBeg, int iSubLen)
{
	char szBuffer[MAX_STRLEN];
	lstrcpy(szBuffer, szString + iSubBeg + iSubLen);
	lstrcpy(szString + iSubBeg, szBuffer);
}


void ClipComment(LPSTR szLine, LPCSTR szCommentSign)
{
	int iComBeg = FindSubString(szLine, szCommentSign);
	if(iComBeg >= 0)
		szLine[iComBeg] = '\0';
}






